require("love_reactor/all")

admirer_sprites = {
  love.graphics.newImage("sprites/Nature33.png"),
  love.graphics.newImage("sprites/Nature34.png"),
  love.graphics.newImage("sprites/Nature35.png"),
  love.graphics.newImage("sprites/Nature36.png"),
  love.graphics.newImage("sprites/Nature37.png"),
  love.graphics.newImage("sprites/Nature38.png"),
  love.graphics.newImage("sprites/Nature39.png"),
  love.graphics.newImage("sprites/Nature40.png"),
  love.graphics.newImage("sprites/Nature41.png"),
  love.graphics.newImage("sprites/Nature42.png"),
  love.graphics.newImage("sprites/Nature43.png"),
  love.graphics.newImage("sprites/Nature44.png"),
  love.graphics.newImage("sprites/Nature45.png"),
  love.graphics.newImage("sprites/Nature46.png"),
  love.graphics.newImage("sprites/Nature47.png"),
  love.graphics.newImage("sprites/Nature48.png"),
  love.graphics.newImage("sprites/Nature49.png"),
  love.graphics.newImage("sprites/Nature50.png"),
  love.graphics.newImage("sprites/Nature51.png"),
  love.graphics.newImage("sprites/Nature52.png"),
  love.graphics.newImage("sprites/Nature53.png"),
  love.graphics.newImage("sprites/Nature54.png"),
  love.graphics.newImage("sprites/Nature55.png"),
  love.graphics.newImage("sprites/Nature56.png"),
  love.graphics.newImage("sprites/Nature57.png"),
  love.graphics.newImage("sprites/Nature58.png"),
  love.graphics.newImage("sprites/Nature59.png"),
  love.graphics.newImage("sprites/Nature60.png"),
  love.graphics.newImage("sprites/Nature61.png"),
  love.graphics.newImage("sprites/Nature62.png"),
  love.graphics.newImage("sprites/Nature63.png"),
  love.graphics.newImage("sprites/Nature64.png"),
  love.graphics.newImage("sprites/Nature65.png"),
  love.graphics.newImage("sprites/Nature66.png"),
  love.graphics.newImage("sprites/Nature67.png"),
  love.graphics.newImage("sprites/Nature68.png"),
  love.graphics.newImage("sprites/Nature69.png"),
  love.graphics.newImage("sprites/Nature70.png"),
  love.graphics.newImage("sprites/Nature71.png"),
  love.graphics.newImage("sprites/Nature72.png"),
  love.graphics.newImage("sprites/Nature73.png"),
  love.graphics.newImage("sprites/Nature74.png"),
  love.graphics.newImage("sprites/Nature75.png"),
  love.graphics.newImage("sprites/Nature76.png"),
}

scream_sounds = {
  "sfx/scream1.mp3",
  "sfx/scream2.mp3",
  "sfx/scream3.mp3",
  "sfx/scream4.mp3",
  "sfx/scream5.mp3",
  "sfx/scream6.mp3",
  "sfx/scream7.mp3",
  "sfx/scream8.mp3",
}

Lady = class({
  sprite = love.graphics.newImage("sprites/lady.png")
}, {drawable, singleton, collidable})

Admirer = class({
  drag = {
    x = 100,
    y = 100 
  }
}, {drawable, movable, collidable})

Lava = class({
  sprite = love.graphics.newImage("sprites/lava.psd"),
  depth = -100
}, {drawable, collidable, movable, singleton})

collision_stream
  .map(collision_between(Admirer.instances, Admirer.instances))
  .filter(function(e) return e end)
  .map(function(e)
    simple_collisions(e.a, e.b)
  end)

update_stream
  .map(function()
    for _, admirer in pairs(Admirer.instances.values()) do
      admirer.acceleration = vector.mult(vector.normalize(vector.sub(admirer.position, Lady.instance.position)), -500)
    end
  end)

update_stream
  .map(function()
    Lady.instance.position = {
      x = love.mouse.getX(),
      y = love.mouse.getY()
    }
  end)


collision_stream
  .map(collision_between(Lava.instances, Admirer.instances))
  .filter(function(e) return e end)
  .map(function(e)
    e.b.destroy()
    love.audio.newSource(table.pick_random(scream_sounds)):play()
  end)

collision_stream
  .map(collision_between(Lava.instances, Lady.instances))
  .filter(function(e) return e end)
  .map(function(e)
    love.audio.newSource(table.pick_random(scream_sounds)):play()
  end)


update_stream
  .map(function()
    if Lava.instance.y - Lava.instance.height / 2 < 0 then
      love.event.quit()
    end
  end)

function love.load()
  love.graphics.setBackgroundColor(colors.white)
  Lady.new()

  for _, sprite in pairs(admirer_sprites) do
    Admirer.new({
      sprite = sprite,
      x = math.random(0, love.window.getWidth()),
      y = math.random(0, love.window.getHeight())
    })
  end

  Lava.new({
    x = love.window.getWidth() / 2,
    y = love.window.getHeight() + 700,
    velocity = {
      x = 0,
      y = -50
    }
  })
  love.audio.newSource("sfx/songo.ogg"):play()
end
